
;************************************************************************************
;Dessine un polygone mappe (les pixels 'blans' ne sont pas affichees)
;************************************************************************************
draw_transparent_textured_polygon MACRO
 draw_textured_polygon t_\1,clear_pix
 ENDM

clear_pix MACRO
 bclr.b d6,d1
 ENDM
;************************************************************************************
;Dessine un polygone mappe
;vscreen contient l'adresse de l'ecran virtuel
;
;************************************************************************************
draw_textured_polygon MACRO
;*************************************************************************************
;**********************   Dtermine l'ordonne minimale et maximale :   **************
;*************************************************************************************

 move.l adresse_de_l_ecran_virtuel,tampon_ecran

 lea polygone,a4
 move.w (a4)+,d7                ;charge le nbre d'itrations
 lea coordonnees_de_mapping,a6
;***  a6:=addr(coordonnes_de_mapping)-addr(polygone)
 suba a4,a6

 move.l a4,a2
 move.l a4,coord_min            ;coord_min pointe sur la premiere ordonne du polygone
 move.w 2(a4),ymax              ;ymax=premiere valeur
 move.w 2(a4),ymin              ;    =ymin
 lea 4(a4),a4                   ;on pointe sur le prochain point

mini_maxi_\1:
 subq.w #1,d7
 beq fin_mini_maxi_\1              ;fin du polygone
 move.l (a4)+,d0                ;d0.l:=abscisse.w + ordonne.w

 cmp.w ymax,d0                  ;compare l'ordonne maxi avec celle courante
 ble no_new_maxi_\1
 move.w d0,ymax                 ;nouveau maximum
no_new_maxi_\1:
 cmp.w ymin,d0
 bge mini_maxi_\1
 move.w d0,ymin                 ;nouveau minimum
 lea -4(a4),a2                  ;a2 pointe sur le minimum
 jmp mini_maxi_\1

fin_mini_maxi_\1:

 lea -4(a4),a4
 move.l a4,coord_max         ;coord_max pointe sur la derniere ordonne du polygone

;*** Si ymax<0 de l'cran on arrte le tracage
 cmpi.w #0,ymax
 blt fin_du_tracage_\1

;*** Si ymax>hauteur de l'cran on arrte le tracage
 cmpi.w #LCD_HEIGHT,ymin
 bgt fin_du_tracage_\1

;***  Calcul de l'increment principal :
 movea.l a2,a3               ;a3,a2 pointent ts les deux sur le maximum
 movea.l a2,a4               ;Prserve a2
;On prend les points suivant:
 point_suivant_gauche pinc_\1
 point_suivant_droit  pinc_\1

 mapping \1

;***  Fin du calcul de l'incrment principal.

 movea.l a4,a2
 movea.l a4,a3

;***  on commence  la ligne ymax :
 moveq.l #0,d0
 move.w ymin,d0          ;ymin est en haut de l'cran
 move.w d0,yi            ;Ne soyez pas tentez pour optimiser l, OK ?

;***  On suppose que a0 contient dj l'adresse de destination pour crire l'image
 tst.w yi
 bmi clip_haut_pas_de_dcalage_\1  ;Pas d'adresse ngative non non et non
 move.l d0,d1
 asl.l #5,d0
 asl.l #1,d1
 sub.l d1,d0
 add.l d0,tampon_ecran
clip_haut_pas_de_dcalage_\1:

;***  a0 est cens pointer sur la ligne ymin  l'cran

;***  partie du clipping :
 move.w #LCD_HEIGHT,d0
 cmp.w  ymax,d0
 bgt no_clip_bas_\1           ;si ymax < hauteur_de_l_ecran
 subq.l #1,d0
 move.w d0,ymax            ;alors aucune raison de dpasser la hauteur de l'cran
no_clip_bas_\1:

;*************************************************************************************
;*******  Affichage du polygone (Boucle principale) :  *******************************
;*************************************************************************************
next_line_\1:
;************************************************************************************
;***  si y<=ymin ou y<0 on arrte le trac : (clipping haut)*************************
;************************************************************************************
;***  On le teste ds le dbut pour envisag le cas du polygone plat (suivant l'horizontale)
 move.w ymax,d0
 cmp.w yi,d0
 ble fin_du_tracage_\1     ;si yi > ymax alors on arrte

 increment_ligne_gauche \1
 increment_ligne_droit \1

 tst.w yi
 bmi   clip_haut_\1

;************************************************************************************
;***************   Affichage de la ligne avec la texture :   ************************
;************************************************************************************
;************************************************************************************

 move.w pos_gauche,d2
 asr.w  #7,d2                    ;d2 contient l'absice courant gauche
 cmpi.w #LCD_WIDTH,d2
 bge y_a_plus_de_ligne_\1        ;partie du clipping : cas ou on ne dessine pas du tout la ligne
 move.w pos_droit,d3
 asr.w  #7,d3                    ;d3 contient l'absice courant gauche
 bmi y_a_plus_de_ligne_\1

;******************   PREPARE LES PARAMETRES (INCREMENTS) POUR DESSINER LA LIGNE  ************
 moveq.l #0,d7
 move.w  d3,d7
 sub.w   d2,d7       ;d7 est le nombre d'itrations (x2_clipp - x1_clipp)
; beq     y_a_plus_de_ligne_\1
 bmi     y_a_plus_de_ligne_\1
                     ;Si delta_x est <= 0 alors on ne trace pas la ligne


;***  On charge les coordonne map de dpart :
; (simple)
;***  sur x
 move.l texture_pos_gauche_x,d4
;***  sur y
 move.l texture_pos_gauche_y,d5

 tst.w d2
 bpl no_clip_gauche_\1

 move.w d3,d7          ;nbre d'incrementation = d3
 neg.w  d2
;***  Ajuste le clipping gauche sur x
 move.l increment_principal_x,d1
 muls   d2,d1
 add.l  d1,d4
;et sur y
 move.l increment_principal_y,d1
 muls   d2,d1
 add.l  d1,d5
 clr.w d2

no_clip_gauche_\1:

;***  Charge le dpart de l'image:
 movea.l tampon_ecran,a1

;***  a6 pointe sur le long word ou la ligne doit s'afficher.

 moveq.l #0,d0
 move.w d2,d0
 asr.w  #3,d0        ;d0:=(x1_clipp) div 8

 adda.l d0,a1        ;a1 pointe maintenant sur le long word  afficher
                     ;en rsum a6:=#LCD_MEM + y * 300 + x div 32

;Calcule le dcalage  "l'intrieur" du long word pour l'affichage de la ligne
 move.b d2,d6
 not.b  d6           ;d6:=dcalage en bits
 andi.b #7,d6

;***  Clipping droit tout  la fin

 move.l #LCD_WIDTH,d0
 cmp.w d7,d0
 bgt no_clip_droit_\1

 subq.w #1,d0
 move.w d0,d7            ;nouveau nbre d'incrment=largeur de l'cran

no_clip_droit_\1:

;***  On adapte le format :
 moveq.l #0,d0
 move.b d5,d0
 ror.l	#8,d0

 move.l d4,d1
 asr.w #8,d1
 asr.w #8,d5
 muls  #largeur_de_l_image,d5
 add.w d1,d5
 add.l d0,d5

 lea image,a0
 add.l a0,d5

 move.b special_add1,d2
 move.l special_add2,d3

;***  Rcapitulation des paramtres demands en entre de boucle :
;       a6 pointe sur l'octet du dbut de la ligne  afficher
;        d6 est le dcalage en bits en (a6) du dbut de la ligne  afficher
;       d4 est la position map de texture sur x de dpart
;       d2 est l'incrment sur x de la texture
;       idem pour d3,d5 pour les coordonnes map sur y

;***  Boucle d'affichage de la ligne :

 move.b (a1),d1                 ;on charge l'ancien tat du word

n_pixel_suivant_\1:

;***  Calcul la vraie adresse de la texture
 add.b d2,d4
 addx.l d3,d5
 bcc    no_carry_flag_\1
 addi.l #largeur_de_l_image,d5
no_carry_flag_\1:
 move.l d5,a0

 tst.b (a0)                      ;on teste le pixel source
 beq    pas_de_pixel_\1          ;Allum

;***  Affiche le pixel :
 
 bset.b d6,d1                    ;oui alors on allume le pixel dans le registre tampon : d1
                                 ;OU logique avec l'ancien tat du pixel

;***   Point suivant :
 subq.b #1,d6                    ;dcalage du masque
 bpl n_meme_mot_\1
 jmp n_mot_suivant_\1

;***  Eteint le pixel :
pas_de_pixel_\1:
 \2      			;efface ou non le pixel

;***   Point suivant :
 subq.b #1,d6                   ;dcalage du masque
 bpl n_meme_mot_\1

;Est ce qu'on passe au word suivant pour l'criture du pixel :
;oui
n_mot_suivant_\1:
 move.b d1,(a1)+                 ;On affiche le mot (paquet de 16 pixel)
 move.b #7,d6
 move.b (a1),d1                  ;On prend l'ancien tat du mot
 DBra d7,n_pixel_suivant_\1
 jmp n_dernier_mot_\1

;non
n_meme_mot_\1:
 DBra d7,n_pixel_suivant_\1

;***  Dernier word  afficher
n_dernier_mot_\1:
 move.b d1,(a1)               ;Ou logique pour afficher 16 pixel - un mot

y_a_plus_de_ligne_\1:

;************************************************************************************
;***  On dcrmente le pointeur sur la ligne  afficher
 add.l #largeur_reelle_de_l_ecran_en_octets,tampon_ecran

clip_haut_\1:

;***  prochaine ligne  tracer : on dcrmente y
 addq.w #1,yi

;***   Incrment de ligne :

 move.w inc_droit,d0
 add.w d0,pos_droit

 move.w inc_gauche,d0
 add.w d0,pos_gauche

 move.l texture_inc_gauche_x,d0
 add.l d0,texture_pos_gauche_x

 move.l texture_inc_gauche_y,d0
 add.l d0,texture_pos_gauche_y

 jmp next_line_\1


fin_du_tracage_\1:
 ENDM
